var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { hasDirectives, checkDocument, removeDirectivesFromDocument, } from 'apollo-utilities';
import gql from 'graphql-tag';
import { print } from 'graphql/language/printer';
import { ApolloLink, } from 'apollo-link';
var DirectiveLink = /** @class */ (function (_super) {
    __extends(DirectiveLink, _super);
    function DirectiveLink(directivesConfig) {
        var _this = _super.call(this) || this;
        _this.directivesConfig = [];
        _this.removedCache = new Map();
        if (!directivesConfig || !Array.isArray(directivesConfig)) {
            throw new Error('A DirectiveLink must be initialized with an array of options');
        }
        _this.directivesConfig = directivesConfig;
        return _this;
    }
    DirectiveLink.prototype.removeDirectivesFromDocument = function (query) {
        var cached = this.removedCache.get(query);
        if (cached)
            return cached;
        checkDocument(query);
        var directivesToRemove = this.directivesConfig
            .filter(function (o) { return o.remove !== false; })
            .map(function (o) { return ({ name: o.directive }); });
        var docClone = removeDirectivesFromDocument(directivesToRemove, query);
        var cleanedQuery = gql(print(docClone));
        this.removedCache.set(query, cleanedQuery);
        return cleanedQuery;
    };
    DirectiveLink.prototype.request = function (operation, forward) {
        var query = operation.query;
        var directivesToCheck = this.directivesConfig.map(function (o) { return o.directive; });
        if (hasDirectives(directivesToCheck, query)) {
            this.directivesConfig.map(function (_a) {
                var directive = _a.directive, callback = _a.callback;
                if (hasDirectives([directive], query)) {
                    callback(operation, forward);
                }
            });
            operation.query = this.removeDirectivesFromDocument(query);
        }
        return forward ? forward(operation) : null;
    };
    return DirectiveLink;
}(ApolloLink));
export { DirectiveLink };
//# sourceMappingURL=DirectiveLink.js.map