(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('apollo-utilities'), require('graphql-tag'), require('graphql/language/printer'), require('apollo-link')) :
    typeof define === 'function' && define.amd ? define(['exports', 'apollo-utilities', 'graphql-tag', 'graphql/language/printer', 'apollo-link'], factory) :
    (factory((global['apollo-link-directive'] = {}),global.apollo.utilities,global.gql,global.printer,global.apolloLink.core));
}(this, (function (exports,apolloUtilities,gql,printer,apolloLink) { 'use strict';

    gql = gql && gql.hasOwnProperty('default') ? gql['default'] : gql;

    var __extends = (undefined && undefined.__extends) || (function () {
        var extendStatics = function (d, b) {
            extendStatics = Object.setPrototypeOf ||
                ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
                function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
            return extendStatics(d, b);
        };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DirectiveLink = /** @class */ (function (_super) {
        __extends(DirectiveLink, _super);
        function DirectiveLink(directivesConfig) {
            var _this = _super.call(this) || this;
            _this.directivesConfig = [];
            _this.removedCache = new Map();
            if (!directivesConfig || !Array.isArray(directivesConfig)) {
                throw new Error('A DirectiveLink must be initialized with an array of options');
            }
            _this.directivesConfig = directivesConfig;
            return _this;
        }
        DirectiveLink.prototype.removeDirectivesFromDocument = function (query) {
            var cached = this.removedCache.get(query);
            if (cached)
                return cached;
            apolloUtilities.checkDocument(query);
            var directivesToRemove = this.directivesConfig
                .filter(function (o) { return o.remove !== false; })
                .map(function (o) { return ({ name: o.directive }); });
            var docClone = apolloUtilities.removeDirectivesFromDocument(directivesToRemove, query);
            var cleanedQuery = gql(printer.print(docClone));
            this.removedCache.set(query, cleanedQuery);
            return cleanedQuery;
        };
        DirectiveLink.prototype.request = function (operation, forward) {
            var query = operation.query;
            var directivesToCheck = this.directivesConfig.map(function (o) { return o.directive; });
            if (apolloUtilities.hasDirectives(directivesToCheck, query)) {
                this.directivesConfig.map(function (_a) {
                    var directive = _a.directive, callback = _a.callback;
                    if (apolloUtilities.hasDirectives([directive], query)) {
                        callback(operation, forward);
                    }
                });
                operation.query = this.removeDirectivesFromDocument(query);
            }
            return forward ? forward(operation) : null;
        };
        return DirectiveLink;
    }(apolloLink.ApolloLink));

    exports.DirectiveLink = DirectiveLink;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=bundle.umd.js.map
